// YUSBHid.cpp: CYUSBHid NX̃Cve[V
// hid.dll [hKv
// 
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "YUSBHid.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CYUSBHid::CYUSBHid()
{
	// ֐̃[h
	m_hModule = LoadLibrary( "HID.DLL" );
	if(m_hModule == NULL) return;

	HidD_GetHidGuid = (HIDD_GETHIDGUID*)GetProcAddress( m_hModule, "HidD_GetHidGuid" );
	HidD_GetAttributes = (HIDD_GETATTRIBUTES*)GetProcAddress( m_hModule, "HidD_GetAttributes" );
	HidD_GetFeature = (HIDD_GETFEATURE*)GetProcAddress( m_hModule, "HidD_GetFeature" );
	HidD_SetFeature = (HIDD_SETFEATURE*)GetProcAddress( m_hModule, "HidD_SetFeature" );

	HidD_GetProductString = (HIDD_GETPRODUCTSTRING*)GetProcAddress( m_hModule, "HidD_GetProductString" );
	HidD_GetManufacturerString = (HIDD_GETMANUFACTURERSTRING*)GetProcAddress( m_hModule, "HidD_GetManufacturerString" );

	m_hDevice = 0;
	m_hRead = m_hWrite = 0;
}

CYUSBHid::~CYUSBHid()
{
	CloseDevice();
	if(m_hModule == NULL) return;
	FreeLibrary(m_hModule);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// foCXJĂ邩
BOOL CYUSBHid::DeviceIsOpen()
{
	if(m_hDevice) return TRUE;
	else return FALSE;
}

// foCXJ
// useReportIDs : 0w
int CYUSBHid::OpenDevice(int vendorID, int productID, int useReportIDs, char* vendorName, char* productName)
{
	if(m_hModule == NULL) return -1; // DLL Ȃ
	if(m_hDevice) CloseDevice();
	m_hDevice = INVALID_HANDLE_VALUE;
	
	HWND hWnd = NULL; // gbvxEBhẼnhGƂ肠NULLɂĂ

	GUID hidGUID; // GUID
	HDEVINFO deviceInfoList; // foCXZbg
	SP_DEVICE_INTERFACE_DATA deviceInfo; // C^tF[XɊւ
	deviceInfo.cbSize = sizeof(deviceInfo);

	SP_DEVICE_INTERFACE_DETAIL_DATA* pDeviceDetails = NULL; // C^tF[XɊւڍ׏

	HidD_GetHidGuid(&hidGUID); // HID  NXGUID 𓾂
	deviceInfoList = SetupDiGetClassDevs(&hidGUID, NULL, hWnd, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE); // foCXZbg𓾂

	// foCX𑖍Ă䂭
	for(int i=0; i<512; i++){
		DWORD reqSize;
		HIDD_ATTRIBUTES deviceAttributes;
		deviceAttributes.Size = sizeof(deviceAttributes);

		if(m_hDevice != INVALID_HANDLE_VALUE) { //  continue Ŗ߂ĂƂA nhJ
			CloseHandle(m_hDevice);
			m_hDevice = INVALID_HANDLE_VALUE;
		}

		// C^tF[XɊւڍ׏𓾂
		if(!SetupDiEnumDeviceInterfaces(deviceInfoList, 0, &hidGUID, i, &deviceInfo)) break;
		SetupDiGetDeviceInterfaceDetail(deviceInfoList, &deviceInfo, NULL, 0, &reqSize, NULL); // ܂AKvȃTCY𓾂
		
		// ̊m
		if(pDeviceDetails != NULL) delete [] pDeviceDetails;
		pDeviceDetails = (SP_DEVICE_INTERFACE_DETAIL_DATA*) new char[reqSize];
		pDeviceDetails->cbSize = sizeof(*pDeviceDetails);

		SetupDiGetDeviceInterfaceDetail(deviceInfoList, &deviceInfo, pDeviceDetails, reqSize, &reqSize, NULL);
		
		// HID foCXJ
		m_hDevice = CreateFile(pDeviceDetails->DevicePath, GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL); 

		if(m_hDevice == INVALID_HANDLE_VALUE) continue; // JȂꍇAJ

		HidD_GetAttributes(m_hDevice, &deviceAttributes); // J HID foCX VendorID, ProductID 𓾂
		if((deviceAttributes.VendorID == vendorID) && (deviceAttributes.ProductID == productID)) {
			// PID, VID v
			
			char buffer[512];
			if(!HidD_GetManufacturerString(m_hDevice, buffer, sizeof(buffer))){
				continue;
			}
			ConvUniToAscii(buffer);
			if(strcmp(vendorName, buffer) != 0){
				continue;
			}
			if(!HidD_GetProductString(m_hDevice, buffer, sizeof(buffer))){
				continue;
			}
			ConvUniToAscii(buffer);
			if(strcmp(productName, buffer) != 0){
				continue;
			}
			
			// vendorName, productName v
			break; 
		}
	}

	SetupDiDestroyDeviceInfoList(deviceInfoList); // foCXZbg ̉
	if(pDeviceDetails != NULL) delete [] pDeviceDetails;

	if(m_hDevice == INVALID_HANDLE_VALUE) {
		m_hDevice = NULL;
		return -1;
	}

	// ǂݍ݁Eonh𓾂
	m_hWrite = CreateFile((pDeviceDetails->DevicePath), GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
	m_hRead  = CreateFile((pDeviceDetails->DevicePath), GENERIC_READ,  FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);


	// ȂA̎_ m_hDevice  CreateFile Ă܂܂ł

	return 0;
}

// foCXƂ
int CYUSBHid::CloseDevice()
{
	if(m_hDevice == 0) return -1;

	if(m_hWrite) CloseHandle(m_hWrite);
	if(m_hRead)  CloseHandle(m_hRead);
	m_hRead = m_hWrite = 0;

	CloseHandle(m_hDevice);
	return 0;
}

// foCXf[^ǂݎiRg[ʐMj
// Al: 0 Ő
// buffer[0]: ReportID 
// buffer[1-]: Mꂽf[^
int CYUSBHid::GetReport(char *buffer, int reportNumber, int len)
{
	if(m_hDevice == 0) return -1;
	if(m_hModule == NULL) return -1;
    buffer[0] = reportNumber;

	int ret = HidD_GetFeature(m_hDevice, buffer, len);

	if(ret == 0) return -1;
	else return 0;
}

// foCXɃf[^𑗂iRg[ʐMj
// Al: 0 Ő
// buffer[0]: ReportID 
// buffer[1-]: Mf[^
int CYUSBHid::SendReport(char *buffer, int len)
{
	if(m_hDevice == 0) return -1;
	if(m_hModule == NULL) return -1;

	int ret = HidD_SetFeature(m_hDevice, buffer, len);

	if(ret == 0) return -1;
	else return 0;
}

//////
void CYUSBHid::ConvUniToAscii(char *buffer)
{
	unsigned short  *uni = (unsigned short *)buffer;
	char            *ascii = buffer;

	while(*uni != 0){
		if(*uni >= 256){
			*ascii++ = '?';
		}else{
			*ascii++ = (char) *uni++;
		}
	}
	*ascii++ = 0;
}

// foCXɃf[^𑗂iC^vgʐMj
int CYUSBHid::SendOutput(char *buffer, int len)
{
	if(m_hDevice == 0) return -1;
	if(m_hModule == NULL) return -1;
	if(m_hWrite == 0) return -1;
	
	DWORD temp;
	if(WriteFile(m_hWrite, buffer, len, &temp, 0) != TRUE) return -1;

	return 0;
}

// foCXf[^𓾂iC^vgʐMj
int CYUSBHid::GetInput(char *buffer, int len)
{
	if(m_hDevice == 0) return -1;
	if(m_hModule == NULL) return -1;
	if(m_hRead == 0) return -1;
	
	DWORD temp;
	if(ReadFile(m_hWrite, buffer, len, &temp, 0) != TRUE) return -1;

	return 0;
}
